/* Aufg004.c */

#include <stdio.h>
#include <stdlib.h>

double quotient(double, double);
void abschluss1(void);
void abschluss2(void);

char* *params;

int main(int argc, char* argv[]) {
	if (atexit(abschluss2)!=0)
		printf("\nabschluss2 nicht aktivierbar.\n");
	if (argc < 3) {
		printf("\nUsage Aufg004 <dividend> <divisor>\n");
		exit(EXIT_FAILURE);
	}
	params = argv;
	printf("\nDer Quotient von ");
	printf(argv[1]);
	printf(" durch ");
	printf(argv[2]);
	printf(" ist ");
	printf("%f",quotient(atof(argv[1]), atof(argv[2])));
        return EXIT_SUCCESS;
}

double quotient(double dividend, double divisor) {
	if (divisor == 0) {
		if (atexit(abschluss1)!=0)
			printf("\nabschluss1 nicht aktivierbar.\n");
		printf("Fehler: Division durch Null!\n");
		exit(EXIT_FAILURE);
	}
	return dividend/divisor;
}

void abschluss1(void) {
	printf("1. Parameter: %s\n",params[1]);
	printf("2. Parameter: %s\n",params[2]);
}

void abschluss2(void) {
	printf("\n\n");
}
