/* Bspl029.c */

#include <stdio.h>	/* */

#define MAXVERSUCHE 5
#define MAXLAENGE 25
#undef getchar
#undef putchar

void clearview(void);
int istenthalten(int, const char*, int*, int*);

char wort[MAXLAENGE+1];
int geraten[MAXLAENGE];
int fehler = 0;

int main() {

	int i, fertig = 0;
	int b;

	clearview();
	/* 1. Spieler gibt zu ratendes Wort ein */
	do
		printf("\nzu ratendes Wort (max. %i Buchst.): ", MAXLAENGE);
	while (scanf("%25s", wort) < 1);
	/* Merker auf Null (=falsch) setzen */
	for (i = 0; i < MAXLAENGE; i++)
		geraten[i] = 0;
	clearview();
	/* 2. Spieler rt */
	while (fehler <= MAXVERSUCHE && ! fertig) {
		puts("");
		i = -1;
		while (wort[++i])
			putchar(geraten[i] ? wort[i] : '_');
		printf("\nBuchstabe? ");
		getchar();
		b = getchar();
		fehler += istenthalten(b, wort, geraten, &fertig);
	}
	puts("");
	i = -1;
	while (wort[++i])
		putchar(geraten[i] ? wort[i] : '_');
	if (fertig) {
		puts("\nSehr gut!!");
		printf("Nur %i mal falsch geraten!",fehler);
	}
	else {
		printf("\nLeider %i mal falsch geraten!",fehler);
		printf("\nDas Wort lautet '%s'", wort);
	}
	putchar('\n');
	return 0;
}

void clearview(void) {
	/* Bildschirm 'lschen' */
	int i;
	for (i = 0; i < 100; i++)
		puts("");
}


int istenthalten(int b, const char *w, int *m, int * f) {
	/* suchen, ob b in w vorkommt
	   und in m merken             */
	int i = -1, fehler = 1;
	*f = 1;
	while (w[++i]) {
		if (w[i] == b && !m[i]) {
			m[i] = 1;
			fehler = 0;
		}
		if (!m[i])
			*f = 0;
	}
	return fehler;
}
