/* Bspl037.c */

#include <stdio.h>
#include <math.h>

int main() {

	double f;
	float z = 2.345f;
	int c;

	printf("\nEine Dezimalzahl: ");
	scanf("%lf", &f);
#ifdef isfinite
	if (isfinite(f))
		printf("\nDer Wert ist endlich.");
#endif
	if (isinf(f))
		printf("\nDer Wert ist unendlich.");
	if (isnan(f))
		printf("\nDas ist 'Not a Number'.");
	if (isnormal(f))
		printf("\nDie Zahl ist normalisiert.");

	c = fpclassify(f);
	switch (c) {
		case FP_NAN:
			printf("\nUngltiger Fliekommawert.");
			break;
		case FP_INFINITE:
			printf("\nUnendlicher Wert.");
			break;
		case FP_ZERO:
			printf("\nWert ist Null");
			break;
		case FP_NORMAL:
			printf("\nWert ist OK.");
			break;
		case FP_SUBNORMAL:
			printf("\nSehr kleiner Wert.");
	}

	if (isunordered(f, z))
		printf("\nUngeordnete Werte.");
	printf("\nDas war ...");
	if (isgreater(f, z))
		printf("\ngrer als %f.", z);
	if (isgreaterequal(f, z))
		printf("\ngrer als oder gleich %f.", z);
	if (isless(f, z))
		printf("\nkleiner als %f.", z);
	if (islessequal(f, z))
		printf("\nkleiner als oder gleich %f.", z);
	if (islessgreater(f, z))
		printf("\nkleiner oder grer als %f.", z);

	printf("\n");
	return 0;
}
