/* Bspl067.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int verglplz(const void *, const void *);
int verglort(const void *, const void *);

struct ort {
	int plz;
	char ort [26];
};


int main() {

	struct ort ortliste[] = {{45466, "Mlheim"},
		{52349, "Dren"}, {53119, "Bonn"}}; 
	int i;

	printf("\nUnsortierte Liste:");
	for (i = 0; i < 3; i++)
		printf("\n%i %s", ortliste[i].plz, ortliste[i].ort);
	qsort((void *)ortliste, sizeof(ortliste)/sizeof(struct ort),
		sizeof(struct ort), verglplz);
	printf("\n\nSortierte Liste nach PLZ:");
	for (i = 0; i < 3; i++)
		printf("\n%i %s", ortliste[i].plz, ortliste[i].ort);
	qsort((void *)ortliste, sizeof(ortliste)/sizeof(struct ort),
		sizeof(struct ort), verglort);
	printf("\n\nSortierte Liste nach Ort:");
	for (i = 0; i < 3; i++)
		printf("\n%i %s", ortliste[i].plz, ortliste[i].ort);
	printf("\n");
	return 0;
}

int verglplz(const void *el1, const void *el2) {

	struct ort *p1 = (struct ort *)el1;
	struct ort *p2 = (struct ort *)el2;

	if (p1->plz > p2->plz)
		return 1;
	else if (p1->plz < p2->plz)
		return -1;
	else
		return 0;	
}

int verglort(const void *el1, const void *el2) {

	struct ort *p1 = (struct ort *)el1;
	struct ort *p2 = (struct ort *)el2;

	return strcmp(p1->ort, p2->ort);
}