/* Bspl102.c */

#include <stdio.h>
#include <stdlib.h>

struct adr {
	char name[16];
	int plz;
	char ort[26];
};

int main() {

	FILE *fileobj;
	long zeiger;
	int nr, nmax;
	struct adr *memptr, *p;

	fileobj = fopen("MeineListe.dat", "rb");
	if (fileobj == NULL) {
		perror("Fehler beim ffnen");
		return 1;
	}
	else {
		if (fseek(fileobj, 0L, SEEK_END) != 0) {
			perror("Fehler bei fseek");
			clearerr(fileobj);
		}
		else {
			if((zeiger = ftell(fileobj)) == -1L) {
				perror ("Fehler bei ftell");
				clearerr(fileobj);
			}
		}
		nmax = zeiger/sizeof(struct adr);
		if ((memptr = (struct adr *) calloc(nmax, sizeof(struct adr))) == NULL) {
			printf("\nZu wenig Speicher");
			fclose(fileobj);
			return 1;
		}
		rewind(fileobj);
		if (fread(memptr, 
				sizeof(struct adr),
				nmax,
				fileobj) != nmax)
			fprintf(stderr, "\nFehler beim Lesen");
		p = memptr;
		for (nr = 0; nr < nmax; nr++) {
			printf("\nNr. %i: %s, %i %s", nr + 1, p->name,
					p->plz, p->ort);
			p++;
		}
		free(memptr);
		fclose(fileobj);
	}
	printf("\n");
	return 0;
}

