/* Bspl007.c */

#include <stdio.h>
#include <stdlib.h>

double quotient(double, double);

int main(int argc, char* argv[]) {
	if (argc < 3) {
		printf("\nUsage Bspl007 <dividend> <divisor>\n");
		abort();
	}
	printf("\nDer Quotient von ");
	printf(argv[1]);
	printf(" durch ");
	printf(argv[2]);
	printf(" ist ");
	printf("%f",quotient(atof(argv[1]), atof(argv[2])));
        printf("\n");
        return 0;
}

double quotient(double dividend, double divisor) {
	if (divisor == 0) {
		printf("Fehler: Division durch Null!\n");
		exit(EXIT_FAILURE);
	}
	return dividend/divisor;
}