/* Bspl090.c */

#include <stdio.h>

int main(int argc, char *argv[]) {

	FILE *in, *out;
	char puffer[2048];
	int c;

	if (argc < 3) {
		printf("\nAufruf: %s <quelle> <ziel>", argv[0]);
		return 1;
	}
	in = fopen(argv[1], "rb");
	if (in == NULL) {
		perror("Fehler bei Eingabedatei");
		return 1;
	}
	out = fopen(argv[2], "wb");
	if (out == NULL) {
		perror("Fehler bei Ausgabedatei");
		fclose (in);
		return 1;
	}
	setbuf(in, NULL);
	if (setvbuf(out, puffer, _IOFBF, sizeof(puffer)) != 0)
		fprintf(stderr, "\nFehler bei Ausgabepuffer.");
	c = fgetc(in);
	while (!feof(in)) {
		if (fputc(c, out) == EOF) {
			perror("Fehler bei Ausgabe");
			clearerr(out);
		}
		if ((c = fgetc(in)) == EOF) {
			if (ferror(in)) {
				perror("Fehler bei Eingabe");
				clearerr(in);
			}
		}
	}
	fflush(out);
	fclose(in);
	fclose(out);
	printf("\n");
	return 0;
}

