/* Bspl092.c */

#include <stdio.h>
#include <string.h>

struct adr {
	char name[16];
	int plz;
	char ort[26];
};

int main() {

	struct adr adresse;
	FILE *fileobj;
	long zeiger;
	int nr, nmax;

	fileobj = fopen("MeineListe.dat", "rb");
	if (fileobj == NULL) {
		perror("Fehler beim ffnen");
		return 1;
	}
	else {
		if (fseek(fileobj, 0L, SEEK_END) != 0) {
			perror("Fehler bei fseek");
			clearerr(fileobj);
		}
		else {
			if((zeiger = ftell(fileobj)) == -1L) {
				perror ("Fehler bei ftell");
				clearerr(fileobj);
			}
		}
		nmax = zeiger/sizeof(struct adr);
		printf("\nWelche Adresse (1-%i)? ", nmax);
		scanf("%i", &nr);
		while (nr > 0 && nr <= nmax) {
			fseek(fileobj, (long)(nr - 1) * sizeof(struct adr), SEEK_SET);
			if (fread(&adresse, 
					sizeof(struct adr),
					1,
					fileobj) < 1)
				fprintf(stderr, "\nFehler beim Lesen");
			printf("\nNr. %i: %s, %i %s",nr, adresse.name,
					adresse.plz, adresse.ort);
			printf("\nWelche Adresse (1-%i)? ", nmax);
			scanf("%i", &nr);
		}
		fclose(fileobj);
	}
	printf("\n");
	return 0;
}

